%define svnver 1007
%define quicktime4linuxversion 2.1
%define ver 2.1

%def_disable opengl
%def_without manual

Name: cinelerra
Version: %ver
Release: alt0.6.%svnver.1

%define _strip_skiplist %_libdir/cinelerra/*.so
# inline mmx assembly can cause text relocations
#set_verify_elf_method relaxed
%set_verify_elf_method textrel=relaxed

Packager: Igor Vlasenko <viy@altlinux.org>

Summary: Complete production environment for audio and video.
Summary(ru_RU.KOI8-R):      
License: GPL
Group: Video
#Icon: %name-48x48.xpm
#URL: http://www.heroinewarrior.com/cinelerra.php3
URL: http://cvs.cinerella.org
Provides: hvirtual = 1.0.0
Obsoletes: hvirtual

#Source: http://prdownloads.sourceforge.net/heroines/%name-%version-src.tar.bz2
#Source: %{name}-%{version}.tar.bz2
Source: %{name}-%{version}.tar
#SourceCvs: cvs co -P -d:pserver:anoncvs@cvs.cinelerra.org:/var/lib/cvs/external/cinelerra
Source1: %name-16x16.xpm
Source2: %name-32x32.xpm
Source3: %name-48x48.xpm
# manually generated from debian/*.sgml
Source4: %name.1
Source5: mplexhi.1
Source6: mplexlo.1
# fix this patch later!
Patch1: guicast-2.0-alt-prelink-am.patch
Patch6: cinelerra-1.2.2-gcc4-alt-renderfarmfsclient.patch
Patch31: cinelerra-1.2.2-alt-gcc4.patch

%def_without libsndfilehv

# Automatically added by buildreq on Wed Dec 13 2006
BuildRequires: cvs esound-devel gcc-c++ imake libICE-devel libXv-devel libXxf86vm-devel liba52-devel libavc1394-devel libdv-devel libe2fs-devel libfaac-devel libfaad-devel libfftw3-devel libfreetype-devel libiec61883-devel libjpeg-devel liblame-devel libmjpegtools-devel libpng-devel libtheora-devel libtiff-devel libvorbis-devel libx264-devel nasm openexr-devel xorg-cf-files

#AC_CHECK_LIB(uuid, uuid_clear,[libuuid=yes]) libe2fs-devel
#AC_CHECK_LIB(sndfile, sf_open,[libsndfile=yes]) libsndfile-devel
#AC_CHECK_LIB([GL], [glUseProgram],
#PKG_CHECK_MODULES libraw1394 >= 1.2.0,[libraw1394=yes] libraw1394-devel
#PKG_CHECK_MODULES([FFMPEG], [libavcodec libpostproc])
#PKG_CHECK_MODULES(libogg,ogg >= 1.1,[libogg=yes],:)
# added manually:
BuildRequires: libogg-devel libraw1394-devel libsndfile-devel libstdc++-devel pkgconfig
# TODO: build with sisyphus ffmpeg or configure ffmpeg with all yes
#ffmpeg deps added manually
BuildRequires: ffmpeg-devel glib2-devel libalsa-devel libaudiofile-devel libdts-devel libgsm-devel libfltk-devel zlib-devel xvid-devel

# XFree86-devel XFree86-libs = libICE-devel libXv-devel libXxf86vm-devel xorg-cf-files (imake ?)

# for {_libdir}/cinelerra/mpeg2enc.plugin
BuildRequires: mjpegtools
Requires: mjpegtools

%def_with chrpath
%if_with chrpath
BuildRequires: chrpath
%endif
BuildPreReq: libtheora-devel >= 1.0alpha4

%if_enabled manual
BuildRequires: texinfo tetex-core
# tetex-core is outdated:(
%endif

%description
Cinelerra is a complete audio and video authoring
tool. It understands a lot of multimedia formats
(quicktime, avi, ogg) and audio/video compression
codecs (divx, xvid, mpeg1/2, ...)
.
It's about transforming the impossible into reality. The best program for 
video and audio manipulation. Install this, if you need editing and creating
video.

%description -l ru_RU.KOI8-R
     .
     ,   
 .      Linux - 
     .

%package -n libguicast
Version: %ver
Group: System/Libraries
Summary: A toolkit library
%description -n libguicast
 libguicast is a toolkit library mainly used by HeroineVirtual's
 softwares

%package -n libguicast-devel
Group: Development/C
Requires: libguicast = %version
Summary: A toolkit library
%description -n libguicast-devel
 libguicast is a toolkit library mainly used by HeroineVirtual's
 softwares
 .
 This package holds development files for the libguicast library

%if_with libsndfilehv
%package -n libsndfilehv
Group: System/Libraries
Summary: A custom modified Cinelerra's libsndfile library
%description -n libsndfilehv
 Custom modified Cinelerra's libsndfile library
%endif

%package -n libquicktimehv
Group: System/Libraries
Version: %quicktime4linuxversion
Summary: Quicktime 4 Linux Cinelerra internal library
%description -n libquicktimehv
 Quicktime 4 Linux was the first convenient way to read and write 
 uncompressed Quicktime movies on Linux. Today Quicktime 4 Linux 
 is intended for content creation and uncompressed movies. These 
 usually arise during the production phase and not the consumer 
 phase of a movie. It has improvements in colormodel support, 
 bit depth, accuracy, reliability, and codecs, while not 
 stressing economy. 
 .
 Users wishing for a consumer library should use OpenQuicktime or FFMPEG.
 .
 For more informations, see http://heroinewarrior.com/quicktime.php3

%package -n libquicktimehv-devel
Group: Development/C
Version: %quicktime4linuxversion
Requires: libquicktimehv = %quicktime4linuxversion
Summary: Quicktime 4 Linux (Cinelerra internal) library (development files)
%description -n libquicktimehv-devel
 Quicktime 4 Linux was the first convenient way to read and write 
 uncompressed Quicktime movies on Linux. Today Quicktime 4 Linux 
 is intended for content creation and uncompressed movies. These 
 usually arise during the production phase and not the consumer 
 phase of a movie. It has improvements in colormodel support, 
 bit depth, accuracy, reliability, and codecs, while not 
 stressing economy. 
 .
 Users wishing for a consumer library should use OpenQuicktime or FFMPEG.
 .
 This package holds development files for the Quicktime 4 Linux library
 .
 For more informations, see http://heroinewarrior.com/quicktime.php3

%package -n libmpeg3hv
Version: %ver
Group: System/Libraries
Summary: advanced editing and manipulation of MPEG streams (cinelerra's internal) 
%description -n libmpeg3hv
 Libmpeg3 supports advanced editing and manipulation of MPEG streams. 
 MPEG is normally a last mile format but with libmpeg3 you can edit 
 it like a first mile solution. 
 .
 Unless you have a need for MPEG editing and copying, you're better 
 off using a consumer library like FFMPEG.
 .
 For more informations, see http://heroinewarrior.com/quicktime.php3

%package -n libmpeg3hv-devel
Group: Development/C
Requires: libmpeg3hv = %version
Summary: advanced editing and manipulation of MPEG streams (development files)
%description -n libmpeg3hv-devel
 Libmpeg3 supports advanced editing and manipulation of MPEG streams. 
 MPEG is normally a last mile format but with libmpeg3 you can edit 
 it like a first mile solution. 
 .
 Unless you have a need for MPEG editing and copying, you're better 
 off using a consumer library like FFMPEG.
 .
 This package holds development files for the libmpeg3 library
 .
 For more informations, see http://heroinewarrior.com/quicktime.php3

%package -n libmpeg3hv-utils
Group: Video
Requires: libmpeg3hv = %version
Summary: advanced editing and manipulation of MPEG streams (development files)
%description -n libmpeg3hv-utils
Libmpeg3 supports advanced editing and manipulation of MPEG streams. 
MPEG is normally a last mile format but with libmpeg3 you can edit 
it like a first mile solution. 
.
Unless you have a need for MPEG editing and copying, you're better 
off using a consumer library like FFMPEG.
.
This package holds utilities for the libmpeg3 library
.
For more informations, see http://heroinewarrior.com/quicktime.php3


%prep
#setup -q -n %name-%version
%setup -q -n hvirtual
%patch1 -p0 
%patch6 -p1 
#patch31 -p1

%build
autoreconf -fisv

CONFFLAGS=""
#  --libdir=%_libdir is already set in %%configure
CONFFLAGS="$CONFFLAGS --with-plugindir=%{_libdir}/%name"
CONFFLAGS="$CONFFLAGS --enable-freetype2"
CONFFLAGS="$CONFFLAGS --with-external-ffmpeg"
#CONFFLAGS="$CONFFLAGS --with-buildinfo=svn/recompile"
CONFFLAGS="$CONFFLAGS --with-buildinfo=cust/SVN_rev.%{svnver}_ALTLinux"

%ifarch athlon
  CONFFLAGS="$CONFFLAGS --enable-3dnow"
  %add_optflags -m3dnow
%endif
%ifarch i586
  %remove_optflags -march=i586 -mtune=i686 -mcpu=i686
# anyway, it'll not run on p133/64mb -- p4/1GB is recommended :( 
# furthermore, on old garbage like pmmx/pII/k6 we really need ALL optimizations
  %add_optflags -march=pentium-mmx -mtune=i686
%endif

%ifarch powerpc
%else
  %define _optlevel 3
  %add_optflags -ffast-math -mmmx -minline-all-stringops -fprefetch-loop-arrays -funroll-loops
  #add_optflags -msse -m3dnow # athlonXP
  #add_optflags -msse -msse2 # p4
  CXXFLAGS="%optflags -fno-check-new"
  %ifarch ix86
  %add_optflags %optflags_kernel
   CONFFLAGS="$CONFFLAGS --enable-mmx --enable-x86"
   # uncomment --without-pic if build fails with --enable-x86 --enable-mmx
   # CONFFLAGS="$CONFFLAGS --without-pic"
  %endif
%endif

%configure $CONFFLAGS %subst_enable opengl

%make_build 

%install
%makeinstall plugindir=$RPM_BUILD_ROOT%_libdir/%name
#%make_install DESTDIR=$RPM_BUID_ROOT install

# rename the mpeg3 utils so they can be installed alongside SuSE native versions
pushd $RPM_BUILD_ROOT%{prefix}/bin
#  mv mpeg3toc mpeg3toc.hv
#  mv mpeg3cat mpeg3cat.hv
#  mv mpeg3dump mpeg3dump.hv
  ln -s /usr/bin/mpeg2enc $RPM_BUILD_ROOT%{_libdir}/cinelerra/mpeg2enc.plugin
popd


%if_with chrpath
chrpath -d $RPM_BUILD_ROOT%_libdir/libguicast.so.?.?.?
%endif

# hack to properly build foreign guicast
cp quicktime/colormodels.h $RPM_BUILD_ROOT%_includedir/quicktime
cp quicktime/libdv.h $RPM_BUILD_ROOT%_includedir/quicktime

# Install icons
# backwards compatibility with Master 2x/Compact 30
%{?!_niconsdir:%define _niconsdir %_iconsdir}
%__install -D -m 644 %SOURCE1 $RPM_BUILD_ROOT%_miconsdir/%name.xpm
%__install -D -m 644 %SOURCE2 $RPM_BUILD_ROOT%_niconsdir/%name.xpm
%__install -D -m 644 %SOURCE3 $RPM_BUILD_ROOT%_liconsdir/%name.xpm
# replacing with new native icon
%__mv $RPM_BUILD_ROOT/usr/share/pixmaps/cinelerra.xpm $RPM_BUILD_ROOT%_liconsdir/%name.xpm


# menu support
%__install -d $RPM_BUILD_ROOT%_menudir
cat << EOF > $RPM_BUILD_ROOT%_menudir/%name
?package(%name): longtitle="%summary" \
command="%_bindir/%name" title="%name"  needs="x11" \
section="Multimedia/Video" \
icon="%name.xpm"
EOF

# man pages
%__install -d -m 755 $RPM_BUILD_ROOT%_man1dir
%__install -D -m 644 %SOURCE4 %SOURCE5 %SOURCE6 $RPM_BUILD_ROOT%_man1dir

#fixing *hv-flavour
mv $RPM_BUILD_ROOT%_includedir/mpeg3 $RPM_BUILD_ROOT%_includedir/mpeg3hv 
mv $RPM_BUILD_ROOT%_includedir/quicktime $RPM_BUILD_ROOT%_includedir/quicktimehv 
pushd $RPM_BUILD_ROOT%_includedir; %__ln_s quicktimehv quicktime; popd

# libguicast-devel
%__install -d -m755 $RPM_BUILD_ROOT/%_includedir/guicast
%__install -m644 guicast/*.h guicast/*.inc $RPM_BUILD_ROOT/%_includedir/guicast
cp guicast/bootstrap $RPM_BUILD_ROOT%_bindir/guicast_bootstrap1

# manual
%if_with manual
pushd doc
# sh make_manual.sh
texi2html cinelerra_cv_manual_en.texi
popd
%endif

%{find_lang} %{name}

%post
%update_menus

%postun
%clean_menus

%files -f %{name}.lang
%doc doc/*
%dir %_libdir/cinelerra
%dir %_libdir/cinelerra/fonts
%_bindir/cinelerra
## 2.0 where are?
##%_bindir/mplexhi
%_bindir/mplexlo
# %_libdir/cinelerra/*.plugin
%_libdir/cinelerra/*.so
%exclude %_libdir/cinelerra/*.la
%exclude %_libdir/cinelerra/fonts/*.ttf
%exclude %_libdir/cinelerra/fonts/fonts.dir
%_libdir/cinelerra/shapewipe
%{_libdir}/cinelerra/mpeg2enc.plugin
%_miconsdir/%name.xpm
%_niconsdir/%name.xpm
%_liconsdir/%name.xpm
%_menudir/%name
%_man1dir/*

%if_with libsndfilehv
%files -n libsndfilehv
%_libdir/libsndfile*.so*
%endif

%files -n libguicast
%_libdir/libguicast.so.?*

%files -n libguicast-devel
%_libdir/libguicast.so
%_includedir/guicast
%_bindir/guicast_bootstrap1

%files -n libmpeg3hv-devel
%docdir libmpeg3/docs
%_libdir/libmpeg3hv.*
%_includedir/mpeg3hv/*

%files -n libmpeg3hv
%_libdir/libmpeg3hv-*.so*

%files -n libmpeg3hv-utils
%_bindir/mpeg*

%files -n libquicktimehv-devel
%docdir quicktime/docs
%_libdir/libquicktimehv.*
#%%_includedir/quicktimehv/*
%_includedir/quicktime
%dir %_includedir/quicktimehv
%_includedir/quicktimehv/quicktime.h
%_includedir/quicktimehv/qtprivate.h
%_includedir/quicktimehv/colormodels.h
%_includedir/quicktimehv/libdv.h

%files -n libquicktimehv
%_libdir/libquicktimehv-*.so*

%changelog
* Tue May 15 2007 ALT QA Team Robot <qa-robot@altlinux.org> 2.1-alt0.6.1007.1
- Rebuilt due to libIlmImf.so.2 -> libIlmImf.so.4 soname change.

* Mon Apr 02 2007 Igor Vlasenko <viy@altlinux.ru> 2.1-alt0.6.1007
- svn revision 1007

* Fri Feb 02 2007 Igor Vlasenko <viy@altlinux.ru> 2.1-alt0.6.986
- svn revision 986

* Mon Jan 22 2007 Igor Vlasenko <viy@altlinux.ru> 2.1-alt0.6.984
- new snapshot 984, spec sync with spec.in

* Mon Jan 15 2007 Igor Vlasenko <viy@altlinux.ru> 2.1-alt0.5.980
- svn revision 980
- merged 1.2.2-alt10
- --with-external-ffmpeg

* Wed Dec 13 2006 Igor Vlasenko <viy@altlinux.ru> 2.1-alt0.4.961
- svn revision 961
- opengl support disabled by default (nvidia specific)
- merged x86_64 support (a great thanks to rider@ for sandbox)

* Mon Sep 25 2006 Igor Vlasenko <viy@altlinux.ru> 2.1-alt0.2.909
- svn revision 909

* Fri Sep 22 2006 Igor Vlasenko <viy@altlinux.ru> 2.1-alt0.2.894
- import of heroines cinerella 2.1 completed - new version 2.1
- svn revision 894

* Sat Sep 16 2006 Igor Vlasenko <viy@altlinux.ru> 2.0-alt0.1.885
- svn revision 885

* Wed Sep 13 2006 Igor Vlasenko <viy@altlinux.ru> 2.0-alt0.1
- first build for Daedalus

* Fri Jun 23 2006 Igor Vlasenko <viy@altlinux.ru> 2.0-alt0
- test build 

* Mon May 29 2006 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt6
- C++ fixes for gcc 4
- built with libdts,

* Fri Mar 24 2006 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt5
- added %_bindir/guicast_bootstrap to libguicast-devel

* Fri Mar 24 2006 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt4
- removed useless rpath with chrpath
- added _niconsdir

* Sun Feb 05 2006 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt3
- prelink support with guicast-alt-prelink-am.patch
- ifarch ix86 for x86_64 support

* Mon Nov 21 2005 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt2
- added /usr/include/quicktime to libquicktimehv-devel
- added colormodels.h & libdv.h to libquicktimehv-devel
- fixed russian Summary && description

* Fri Oct 28 2005 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt1
- removed phantom python build dependencies

* Mon Oct 10 2005 Igor Vlasenko <viy@altlinux.ru> 1.2.2-alt0.9
- picked up from orphaned;
- new version;
- new build process based on ``unofficial'' cvs.cinelerra.org
- my patch for Minolta Z3
- split into packages

* Fri Sep 12 2003 Alexander Belov <asbel@altlinux.ru> 1.1.7-alt1
- New version
- Added koi8 russian description and summary to package
- New BuildRequires

* Tue May 20 2003 Alexander Belov <asbel@altlinux.ru> 1.1.6-alt2
- Fixed instalation bug

* Fri May 16 2003 Alexander Belov <asbel@altlinux.ru> 1.1.6-alt1
- New version and new name of package

* Wed Oct 23 2002 AEN <aen@altlinux.ru> 1.0.0-alt2
- first build for Sisyphus, thnx to Alexander Belov!
- MS fonts removed

* Wed Oct 16 2002 Alexander Belov <asbel@mail.ru> 1.0.0-alt1
- Initial release
